#ifndef _ECTOR_GL_BUFFER_BASE_EO_H_
#define _ECTOR_GL_BUFFER_BASE_EO_H_

#ifndef _ECTOR_GL_BUFFER_BASE_EO_CLASS_TYPE
#define _ECTOR_GL_BUFFER_BASE_EO_CLASS_TYPE

typedef Eo Ector_GL_Buffer_Base;

#endif

#ifndef _ECTOR_GL_BUFFER_BASE_EO_TYPES
#define _ECTOR_GL_BUFFER_BASE_EO_TYPES


#endif
#define ECTOR_GL_BUFFER_BASE_MIXIN ector_gl_buffer_base_mixin_get()

EAPI const Eo_Class *ector_gl_buffer_base_mixin_get(void) EINA_CONST;

EOAPI int ector_gl_buffer_base_texture_get(void);

EOAPI int ector_gl_buffer_base_fbo_get(void);

/** If @c true, the image is covering the entire GL texture, ie. it's not part
 * of an atlas.
 *
 * @ingroup Ector_GL_Buffer_Base
 */
EOAPI Eina_Bool ector_gl_buffer_base_whole_get(void);

/**
 * @brief Returns the texture vertices to draw this image with no rotation
 *
 * The 4 points are then defined as (x,y), (x+w,y), (x,y+h), (x+w,y+h).
 *
 * @param[out] x X position of this image inside the texture atlas, from 0 to 1
 * @param[out] y Y position of this image inside the texture atlas, from 0 to 1
 * @param[out] w Width of this image inside the texture atlas, from 0 to 1
 * @param[out] h Height of this image inside the texture atlas, from 0 to 1
 *
 * @ingroup Ector_GL_Buffer_Base
 */
EOAPI void ector_gl_buffer_base_vertices_get(double *x, double *y, double *w, double *h);

#ifdef ECTOR_GL_BUFFER_BASE_PROTECTED
/**
 * @brief Attach to an existing texture (or FBO). Used from child classes.
 *
 * @param[in] fboid
 * @param[in] cspace
 * @param[in] imw
 * @param[in] imh
 * @param[in] tx
 * @param[in] ty
 * @param[in] tw
 * @param[in] th
 * @param[in] l
 * @param[in] r
 * @param[in] t
 * @param[in] b
 *
 * @ingroup Ector_GL_Buffer_Base
 */
EOAPI void ector_gl_buffer_base_attach(int texid, int fboid, Efl_Gfx_Colorspace cspace, int imw, int imh, int tx, int ty, int tw, int th, int l, int r, int t, int b);
#endif


#endif
